; A__AP___A
; 1KB minigame
; by Stefano Tognon
; (C) 2002 Ice Team
; version 1.00

; Well, I like this competition even this year!!!
; This is my 3 game for C64

; Game concept:
;
; You are in the far west some time ago...
; where only the fastest will survive.
; You have to duel with a fast killer...
; because you want to free your A.P. girl...
; from his hand...
; So, make an hard practice, otherwise you died...
; Walk in the desert at moon night and ...
; the practice begin...

      processor 6502
      org 7168

SCREEN     = $E544    ; clean the screen
GETIN      = $FFE4    ; get a char from the keyboard
SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
LINE       = $E9F0    ; calculate current line address
STRING     = $AB1E    ; put a string
KSCAN      = $FF9F    ; keyboard scan

DINI = #128         ; frames delay for display letters

KEY     = $B1      ; the key the player must press for kill
POINTS  = $B2      ; actual points
BLOCK   = $B4      ; block number being used
GO      = $B6      ; 1 if main flow can go away
DELAY   = $B8      ; actual delay frames for interrupt
RESTART = $BA      ; 1 if to restart the game
COUNT   = $BB      ; a count frame

RASTER0 = 30
RASTER1 = 73


      lda  #00
      sta  DELAY
initraster:
      sei
      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      ;lda  $d011
      ;and  #$7f                        ;Set high bit of raster
      ;sta  $d011                       ;position (0)
      lda  #$7f                        ;Set timer interrupt off
      sta  $dc0d

      lda  #$01                        ;Set raster interrupt on
      sta  $d01a
      lda  $dc0d                       ;Acknowledge timer interrupt
      cli


      ; init random number generator
      lda  #129
      sta  54272+18
      sta  54272+14
      sta  54273+14

      ; init screen
      lda  #15
      sta  53281
      jsr  SCREEN

      lda  #90
      ; write the blocks onto the screen with the passed char in A reg.
; we put little block in upper screen, while big in down screen,
; just for giving a 3d illusion
writeBlock:
      sta  BLK1a
      sta  BLK2a
      sta  BLK3a
      sta  BLK4a
      sta  BLK1a+1
      sta  BLK2a+1
      sta  BLK3a+1
      sta  BLK4a+1

      sta  BLK5a
      sta  BLK5a+1
      sta  BLK5b
      sta  BLK5b+1
      sta  BLK5b+2
      sta  BLK5b+3

      sta  BLK6a
      sta  BLK6a+1
      sta  BLK6b
      sta  BLK6b+1
      sta  BLK6b+2
      sta  BLK6b+3

      sta  BLK7a
      sta  BLK7a+1
      sta  BLK7a+2
      sta  BLK7b
      sta  BLK7b+1
      sta  BLK7b+2
      sta  BLK7b+3
      sta  BLK7b+4

      sta  BLK8a
      sta  BLK8a+1
      sta  BLK8a+2
      sta  BLK8b
      sta  BLK8b+1
      sta  BLK8b+2
      sta  BLK8b+3
      sta  BLK8b+4

main:
      ldx  #20
      stx  POINTS
      ldy  #10
      jsr  SET_COOR
      lda  #<Skey
      ldy  #>Skey
      jsr  STRING

      ; attend a key for start
loop:
      jsr  KSCAN                       ; keyboard scan
      jsr  GETIN
      beq  loop

inloop:

      ; choose a random time to delay
      lda  54272+27
      and  #$7f
delay
      cmp  COUNT
      bne  delay

      ; choose a random block
      lda  54272+27
      and  #$07
      sta  BLOCK

      ; choose a random letter
retry2:
      lda  54272+27
      and  #$1F
      cmp  #26
      bpl  retry2
      adc  #65
      sta  KEY

      ; write letter to the block
      ldx  BLOCK
      ldy  BLK_X,x
      lda  BLK_Y,x
      tax
      jsr  SET_COOR
      lda  KEY
      jsr  PUT_CHAR

      lda  DINI                  ; read delay to use
      sta  DELAY                 ; delay for the interrupt before setting go
      lda  #$00
      sta  GO
      sta  RESTART
loopgo:
      lda  GO
      beq  loopgo

      ; remove the block
      ldx  BLOCK
      ldy  BLK_X,x
      lda  BLK_Y,x
      tax
      jsr  SET_COOR
      lda  #32
      jsr  PUT_CHAR

      lda  RESTART
      bne  gomain
      jmp  inloop
gomain:
      jmp main

Skey:
  .byte #31, "PRESS KEY"
Sspace:
  .byte "  ",0
Spoint:
  .byte "POINTS: ",0

BLK1a = 1350
BLK2a = 1320
BLK3a = 1377
BLK4a = 1330

BLK5a = 1468
BLK5b = BLK5a+39

BLK6a = 1488
BLK6b = BLK6a+39

BLK7a = 1595
BLK7b = BLK7a+39

BLK8a = 1655
BLK8b = BLK8a+39

; row/col value for the block position
BLK_X:
  .byte 6, 16, 26, 33, 4, 12, 24, 32

BLK_Y:
  .byte 7, 6, 6, 7, 10, 13, 10, 14

raster0:                    ; set pointer for graphics data
      lda  $d018
      ora  #$08
      and  #$f8
      sta  $d018
                            ; enable bitmap mode standard
      lda  $d011
      ora  #$20
      sta  $d011

      inc  $d019

      lda  #<raster1
      sta  $0314
      lda  #>raster1
      sta  $0315

      lda  #RASTER1                    ;Set low bits of raster
      sta  $d012                       ;position
      ;lda  $d011
      ;and  #$7f                        ;Set high bit of raster
      ;sta  $d011                       ;position (0)

      lda  #0                          ; make always black color
      sta  53280

      ldx  COUNT                       ; keep a frame counter
      inx
      txa
      and  #$7f
      sta  COUNT

      jmp  $ea81

raster1:

      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      ; the above are here for avoid flickering by the next to execute
                            ; set pointer for text data
                            ; enable text mode standard
      lda  $d011
      and  #$dF
      sta  $d011

      lda #21
      sta $d018
      lda #8
      sta $d016

      inc  $d019                       ; ack interr.

      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      ;lda  $d011
      ;and  #$7f                        ;Set high bit of raster
      ;sta  $d011                       ;position (0)

      lda  DELAY
      beq  exit
      dec  DELAY
      bne  scan

      ; you lose points
      inc  GO
      dec  POINTS
      lda  #2
      bne  isdied

scan:
      jsr  KSCAN                       ; keyboard scan
      jsr  GETIN
      beq  noKey

      cmp  KEY                         ; is the same key we look for
      beq  killed

noKilled:
      ; cut off the points
      dec  POINTS
      dec  POINTS
      lda  #2                          ; make a color for not center the block
      sta  53280
isdied:
      cmp  POINTS
      bmi  endkilled

      ; you are died!!!
win:
      inc  RESTART

      bne  endkilled
killed:
      ; add the points
      inc  POINTS
      lda  #125
      cmp  POINTS
      bmi  win

      lda  #5                          ; make a color for center the block
      sta  53280
      inc  GO                          ; the main flow can go away
      lda  #0
      sta  DELAY                  ; clear delay
endkilled:

      ; show the points
      ldx  #20
      ldy  #10
      jsr  SET_COOR
      lda  #<Spoint
      ldy  #>Spoint
      jsr  STRING

      ldx  POINTS
      lda  #0
      jsr  $BDCD                  ; put a integer as string
                                  ; erase some char after the string
      lda  #<Sspace
      ldy  #>Sspace
      jsr  STRING


noKey:
exit:

      jmp  $ea81

 org 8192
 .incbin "sf.raw"
